.\\" auto-generated by docbook2man-spec $Revision: 1.25 $
.TH "DROP DATABASE" "l" "2002-01-30" "SQL - Language Statements" "SQL Commands"
.SH NAME
DROP DATABASE \- remove a database
.SH SYNOPSIS
.sp
.nf
DROP DATABASE \fIname\fR
  
.sp
.fi
.SS "INPUTS"
.PP
.TP
\fB\fIname\fB\fR
The name of an existing database to remove.
.PP
.SS "OUTPUTS"
.PP
.TP
\fBDROP DATABASE\fR
This message is returned if the command is successful.
.TP
\fBDROP DATABASE: cannot be executed on the currently open database\fR
You cannot be connected to the database you are about to remove.
Instead, connect to template1 or any other
database and run this command again.
.TP
\fBDROP DATABASE: may not be called in a transaction block\fR
You must finish the transaction in progress before you can call this command.
.PP
.SH "DESCRIPTION"
.PP
\fBDROP DATABASE\fR removes the catalog entries for an existing
database and deletes the directory containing the data.
It can only be executed by the database owner (usually the user that created
it).
.PP
\fBDROP DATABASE\fR cannot be undone. Use it with care!
.SS "NOTES"
.PP
This command cannot be executed while connected to the target
database. Thus, it might be more convenient to use the shell
script dropdb [\fBdropdb\fR(1)],
which is a wrapper around this command, instead.
.PP
Refer to
CREATE DATABASE [\fBcreate_database\fR(l)]
for information on how to create a database.
.SH "COMPATIBILITY"
.SS "SQL92"
.PP
\fBDROP DATABASE\fR statement is a
PostgreSQL language extension;
there is no such command in SQL92.
