.\\" auto-generated by docbook2man-spec $Revision: 1.25 $
.TH "DROP RULE" "l" "2002-01-30" "SQL - Language Statements" "SQL Commands"
.SH NAME
DROP RULE \- remove a rewrite rule
.SH SYNOPSIS
.sp
.nf
DROP RULE \fIname\fR [, ...]
  
.sp
.fi
.SS "INPUTS"
.PP
.TP
\fB\fIname\fB\fR
The name of an existing rule to drop.
.PP
.SS "OUTPUTS"
.PP
.TP
\fBDROP\fR
Message returned if successful.
.TP
\fBERROR: Rule or view "\fIname\fB" not found\fR
This message occurs if the specified rule does not exist.
.PP
.SH "DESCRIPTION"
.PP
\fBDROP RULE\fR drops a rule from the specified
PostgreSQL rule
system. PostgreSQL
will immediately cease enforcing it and
will purge its definition from the system catalogs.
.SS "NOTES"
.PP
The \fBDROP RULE\fR statement is a
PostgreSQL
language extension.
.PP
Refer to \fBCREATE RULE\fR for
information on how to create rules.
.PP
Once a rule is dropped, access to historical information
the rule has written may disappear.
.SH "USAGE"
.PP
To drop the rewrite rule newrule:
.sp
.nf
DROP RULE newrule;
   
.sp
.fi
.SH "COMPATIBILITY"
.SS "SQL92"
.PP
There is no \fBDROP RULE\fR in SQL92.
