.\\" auto-generated by docbook2man-spec $Revision: 1.25 $
.TH "END" "l" "2002-01-30" "SQL - Language Statements" "SQL Commands"
.SH NAME
END \- commit the current transaction
.SH SYNOPSIS
.sp
.nf
END [ WORK | TRANSACTION ]
  
.sp
.fi
.SS "INPUTS"
.PP
.TP
\fBWORK\fR
.TP
\fBTRANSACTION\fR
Optional keywords. They have no effect.
.PP
.SS "OUTPUTS"
.PP
.TP
\fBCOMMIT\fR
Message returned if the transaction is successfully committed.
.TP
\fBNOTICE: COMMIT: no transaction in progress\fR
If there is no transaction in progress.
.PP
.SH "DESCRIPTION"
.PP
\fBEND\fR is a PostgreSQL
extension, and is a synonym for the SQL92-compatible
COMMIT [\fBcommit\fR(l)].
.SS "NOTES"
.PP
The keywords WORK and TRANSACTION are noise and can be omitted.
.PP
Use ROLLBACK [\fBrollback\fR(l)]
to abort a transaction.
.SH "USAGE"
.PP
To make all changes permanent:
.sp
.nf
END WORK;
   
.sp
.fi
.SH "COMPATIBILITY"
.SS "SQL92"
.PP
\fBEND\fR is a PostgreSQL
extension which provides functionality equivalent to
COMMIT [\fBcommit\fR(l)].
