.\\" auto-generated by docbook2man-spec $Revision: 1.25 $
.TH "RESET" "l" "2002-01-30" "SQL - Language Statements" "SQL Commands"
.SH NAME
RESET \- restore the value of a run-time parameter to a default value
.SH SYNOPSIS
.sp
.nf
RESET \fIvariable\fR
  
.sp
.fi
.sp
.nf
RESET ALL
  
.sp
.fi
.SS "INPUTS"
.PP
.TP
\fB\fIvariable\fB\fR
The name of a run-time parameter. See SET [\fBset\fR(l)] for a list.
.TP
\fBALL\fR
Resets all run-time parameters to default values.
.PP
.SH "DESCRIPTION"
.PP
\fBRESET\fR restores run-time parameters to their
default values. Refer to
SET [\fBset\fR(l)]
for details. \fBRESET\fR is an alternate form for
.sp
.nf
SET \fIvariable\fR TO DEFAULT
   
.sp
.fi
.SH "DIAGNOSTICS"
.PP
See under the SET [\fBset\fR(l)] command.
.SH "EXAMPLES"
.PP
Set DateStyle to its default value:
.sp
.nf
RESET DateStyle;
.sp
.fi
.PP
Set Geqo to its default value:
.sp
.nf
   
RESET GEQO;
.sp
.fi
.SH "COMPATIBILITY"
.PP
\fBRESET\fR is a PostgreSQL extension.
