.\\" auto-generated by docbook2man-spec $Revision: 1.25 $
.TH "SHOW" "l" "2002-01-30" "SQL - Language Statements" "SQL Commands"
.SH NAME
SHOW \- show the value of a run-time parameter
.SH SYNOPSIS
.sp
.nf
SHOW \fIname\fR
  
.sp
.fi
.sp
.nf
SHOW ALL
  
.sp
.fi
.SS "INPUTS"
.PP
.TP
\fB\fIname\fB\fR
The name of a run-time parameter. See
SET [\fBset\fR(l)]
for a list.
.TP
\fBALL\fR
Show all current session parameters.
.PP
.SH "DESCRIPTION"
.PP
\fBSHOW\fR will display the current setting of a
run-time parameter. These variables can be set using the
\fBSET\fR statement or are determined at server start.
.SH "DIAGNOSTICS"
.PP
.TP
\fBERROR: not a valid option name: \fIname\fB\fR
Message returned if \fIvariable\fR does
not stand for an existing parameter.
.TP
\fBERROR: permission denied\fR
You must be a superuser to be allowed to see certain settings.
.TP
\fBNOTICE: Time zone is unknown\fR
If the \fBTZ\fR or \fBPGTZ\fR environment
variable is not set.
.PP
.SH "EXAMPLES"
.PP
Show the current DateStyle setting:
.sp
.nf
SHOW DateStyle;
NOTICE:  DateStyle is ISO with US (NonEuropean) conventions
.sp
.fi
.PP
Show the current genetic optimizer (geqo) setting:
.sp
.nf
SHOW GEQO;
NOTICE:  geqo is on
.sp
.fi
.SH "COMPATIBILITY"
.PP
The \fBSHOW\fR command is a
PostgreSQL extension.
